/* Using const to catch unwanted modifications */
#include <iostream>
#include <ctime>

char get_first1(std::string s) {
  s[1] = 'X'; // Oops, didn't intend to modify
  return s[0];
}

// Use const ---+ here ...
//              |
//              v
char get_first2(std::string* s) {
  (*s)[1] = 'X'; // Oops, didn't intend to modify
  return (*s)[0];
}

int main() {
  std::string name1 = "Fanadu";
  std::string name2 = "Fanadu";

  std::cout << name1 << std::endl;
  std::cout << name2 << std::endl;

  char c1 = get_first1(name1);
  // ... to get a compiler error
  //                   |
  //                   v here
  char c2 = get_first2(&name2);

  std::cout << name1 << std::endl;
  std::cout << name2 << std::endl;

  return 0;
}
