/* First attempt at Person. Provides default constructor
 * and constructor with parameters. */
#include <iostream>

class Person {
public:
  // New: default constructor
  Person() {
  }

  // Don't do this: Person(std::string first_name, std::string name);
  Person(const std::string& _first_name, const std::string& _name) {
    // not using member initializers as per agreement on May 14
    name = _name;
    first_name = _first_name;
  }

  // Don't do this: std::string get_name();
  const std::string& get_name() {
    return name;
  }

  // Don't do this: void set_name(std::string name);
  void set_name(const std::string& _name) {
    name = _name;
  }

  // Don't do this: void set_first_name(std::string first_name);
  void set_first_name(const std::string& _first_name) {
    first_name = _first_name;
  }

  // Don't do this: std::string get_first_name();
  const std::string& get_first_name() {
    return first_name;
  }
  
  void modify_first_name(char first_char) {
    first_name[0] = first_char;
  }

  // Don't do this: const std::string& to_string()
  // because you'd have to return a reference to a local
  // variable.  (Compiler warns.)
  std::string to_string() {
    return first_name + " " + name;
  }

private:
  std::string name;
  std::string first_name;
};


int main() {
  Person you;
  Person* me = new Person("Stephan", "Neuhaus");
  Person* also_me = me; // alias

  std::cout << me->to_string() << std::endl;
  std::cout << also_me->to_string() << std::endl;

  me->modify_first_name('X');
  std::cout << me->to_string() << std::endl;
  std::cout << also_me->to_string() << std::endl;

  /* Here, also_me is an alias for me, therefore modifications to me
   * affect also_me, too. */

  delete me;
  delete also_me; // Runtime error

  return 0;
}
