/* Next attempt at Person. Provides default constructor.
 * copy constructor, and constructor with parameters. */
#include <iostream>

class Person {
public:
  Person() {
  }

  // New: copy constructor
  Person(const Person& p) {
    name = p.name;
    first_name = p.first_name;
  }

  Person(const std::string& _first_name, const std::string& _name) {
    name = _name;
    first_name = _first_name;
  }

  const std::string& get_name() {
    return name;
  }

  void set_name(const std::string& _name) {
    name = _name;
  }

  void set_first_name(const std::string& _first_name) {
    first_name = _first_name;
  }

  const std::string& get_first_name() {
    return first_name;
  }
  
  void modify_first_name(char first_char) {
  first_name[0] = first_char;
  }

  std::string to_string() {
    return first_name + " " + name;
  }

private:
  std::string name;
  std::string first_name;
};


int main() {
  Person you;
  Person me = Person("Stephan", "Neuhaus");
  Person also_me = me; // Make copy

  std::cout << me.to_string() << std::endl;
  std::cout << also_me.to_string() << std::endl;

  me.modify_first_name('X');
  std::cout << me.to_string() << std::endl;
  std::cout << also_me.to_string() << std::endl;

  return 0;
}

