/* Next attempt at Person. Provides empty constructor, destructor
 * copy constructor, assignment operator, and constructor with parameters. */
#include <iostream>

class Address {
public:
  Address(const std::string& _street, const std::string& _city) {
    street = _street;
    city = _city;
  }

  Address(const Address& a) {
    street = a.street;
    city = a.city;
  }

  std::string to_string() {
    return street + ", " + city;
  }

private:
  std::string street;
  std::string city;
};

class Person {
public:
  Person() {
    address = 0;
  }

  Person(const Person& p) {
    name = p.name;
    first_name = p.first_name;
    if (p.address != 0)
      address = new Address(*p.address);
    else
      address = 0;
  }

  Person(const std::string& _first_name, const std::string& _name,
         const Address* _address) {
    name = _name;
    first_name = _first_name;
    if (_address != 0)
      address = new Address(*_address);
    else
      address = 0;    
  }

  const Person& operator=(const Person& p) {
    name = p.name;
    first_name = p.first_name;

    delete address;
    if (p.address != 0)
      address = new Address(*p.address);
    else
      address = 0;
    return *this;
  }

  ~Person() {
    delete address;
  }

  const std::string& get_name() {
    return name;
  }

  void set_name(const std::string& _name) {
    name = _name;
  }

  void set_first_name(const std::string& _first_name) {
    first_name = _first_name;
  }

  const std::string& get_first_name() {
    return first_name;
  }
  
  void modify_first_name(char first_char) {
  first_name[0] = first_char;
  }

  std::string to_string() {
    return first_name + " " + name + " " + address->to_string();
  }

private:
  std::string name;
  std::string first_name;
  Address* address;
};


int main() {
  Address x = Address("Stuhlsatzenhausweg", "Saarbruecken");
  Person me = Person("Stephan", "Neuhaus", &x);

  std::cout << me.to_string() << std::endl;

  return 0;
}

